<?php
/*
  Plugin Name: Tickera - custom ticket template size
  Plugin URI: https://tickera.com/
  Description: Adds one more ticket template size  (108x140mm)
  Author: Tickera.com
  Author URI: https://tickera.com/
  Version: 1.0
  TextDomain: tc

  Copyright 2016 Tickera (https://tickera.com/)
 */

if ( !function_exists( 'tc_additional_ticket_document_size_add_custom' ) ) {
	add_filter( 'tc_additional_ticket_document_size', 'tc_additional_ticket_document_size_add_custom' );

	function tc_additional_ticket_document_size_add_custom( $selected_document_ticket_size ) {
		$tc_general_settings			 = get_option( 'tc_general_setting', false );
		$tc_custom_ticket_template_size	 = isset( $tc_general_settings[ 'tc_custom_ticket_template_size' ] ) ? $tc_general_settings[ 'tc_custom_ticket_template_size' ] : '';

		if ( !empty( $tc_custom_ticket_template_size ) ) {
			$tc_custom_ticket_template_sizes = explode( 'x', trim( $tc_custom_ticket_template_size ) );
			if ( count( $tc_custom_ticket_template_sizes ) == 2 ) {
				?>
				<option value="<?php echo esc_attr( $tc_custom_ticket_template_sizes[ 0 ] . '_' . $tc_custom_ticket_template_sizes[ 1 ] ); ?>" <?php selected( isset( $selected_document_ticket_size ) ? $selected_document_ticket_size : 'A4', $tc_custom_ticket_template_sizes[ 0 ] . '_' . $tc_custom_ticket_template_sizes[ 1 ], true ); ?>><?php echo sprintf( __( 'Custom (%sx%s mm)', 'tc' ), $tc_custom_ticket_template_sizes[ 0 ], $tc_custom_ticket_template_sizes[ 1 ] ); ?></option>
				<?php
			}
		}
	}

}

if ( !function_exists( 'tc_document_paper_size_add_custom_template_size' ) ) {
	add_filter( 'tc_document_paper_size', 'tc_document_paper_size_add_custom_template_size', 99, 1 );

	function tc_document_paper_size_add_custom_template_size( $document_ticket_size ) {
		$tc_general_settings			 = get_option( 'tc_general_setting', false );
		$tc_custom_ticket_template_size	 = isset( $tc_general_settings[ 'tc_custom_ticket_template_size' ] ) ? $tc_general_settings[ 'tc_custom_ticket_template_size' ] : '';

		if ( !empty( $tc_custom_ticket_template_size ) ) {
			$tc_custom_ticket_template_sizes = explode( 'x', trim( $tc_custom_ticket_template_size ) );
			if ( count( $tc_custom_ticket_template_sizes ) == 2 ) {
				if ( $document_ticket_size == $tc_custom_ticket_template_sizes[ 0 ] . '_' . $tc_custom_ticket_template_sizes[ 1 ] ) {
					$document_ticket_size = array( (int) $tc_custom_ticket_template_sizes[ 0 ], (int) $tc_custom_ticket_template_sizes[ 1 ] );
				}
			}
		}
		return $document_ticket_size;
	}

}

if ( !function_exists( 'tc_general_settings_miscellaneous_fields_add_custom_template_size' ) ) {
	add_filter( 'tc_general_settings_miscellaneous_fields', 'tc_general_settings_miscellaneous_fields_add_custom_template_size' );

	function tc_general_settings_miscellaneous_fields_add_custom_template_size( $fields ) {
		$fields [] = array(
			'field_name'	 => 'tc_custom_ticket_template_size',
			'field_title'	 => __( 'Add additional ticket template size', 'tc' ),
			'field_type'	 => 'option',
			'default_value'	 => '',
			'tooltip'		 => '100x200 for instance, will add another ticket template which will have a width of 100mm and height of 200mm',
			'section'		 => 'miscellaneous_settings',
		);
		return $fields;
	}

}
